<template>
  <div class="oneTraject">
    <p>{{ trajData.created_at }}</p>
    <p>{{ trajData.updated_at }}</p>

    <div class="dropdown" :class="{open: is_open}">
      <a href="#" @click.prevent="toggleOpen">
        <span class="iconify" data-inline="false"
              data-icon="akar-icons:more-horizontal"
              style="color: #DF655A; font-size: 24px;"></span>
        <span class="iconify" data-inline="false"
              data-icon="bi:caret-down-fill"
              style="color: #DF655A; font-size: 16px;"></span></a>
      <ul class="dropdown-menu">
        <li><router-link :to="{name: 'Detail', params: {id: trajData.id}}">
          <i class="fa fa-eye"></i> Tonen</router-link></li>
        <li><button
          @click="deleteTraj" class=" btn-del"><i class="fa fa-trash"></i> Verwijderen
        </button></li>
      </ul>
    </div>
  </div>
  <div class="loading" v-show="loading" role="alert">
    <div class="loading-animate"></div>
  </div>
</template>

<script>
export default {
  name: 'OneTraject',
  props: ['trajData'],
  data() {
    return {
      is_open: false,
      trajectId: this.trajData.id,
      loading: false,
    };
  },
/* eslint-disable */
  methods: {
    toggleOpen() {
      this.is_open = !this.is_open;
    },
    async deleteTraj() {
      // eslint-disable-next-line no-restricted-globals
      if (confirm('Wil je zeker dit traject verwijderen?')) {
        this.loading = true;
        try {
          await this.$store.dispatch('dlTrajectory', this.trajectId);
        } catch (errors) {
          console.log(errors);
        } finally {
          // eslint-disable-next-line max-len
          await this.$router.go();
        }
      }
    },
  },
};
</script>

<style scoped lang="scss">
.oneTraject{
  width: 94%;
  background-color: $my-gray;
  display: flex;
  justify-content: space-between;
  align-items: center;
  align-content: center;
  height: 60px;
  padding: 0 3%;
  margin: 5px 0;

  p{
    font-size: 1.3em;
    font-family: $my-text;
    color: $my-blue;
    width: 31.33%;
    line-height: 140%;
    text-align: left;
  }
  .btn-del{
    border: none;
    background-color: transparent;
    font-size: 1em;
    font-family: $my-text;
  }
  .btn-del:hover{
    color: $my-orange;
    transition: .3s;
  }
}

.dropdown{
  max-width: 200px;
}
.dropdown-menu{
  background: #f5f5f5;
  display: none;
  list-style-type: none;
  margin: 0;
  padding: 0;
  box-shadow: 1px 2px 4px #666;
  box-sizing: border-box;
  position: absolute;
  z-index: 9;
  height: 60px;
  min-width: 130px;
}
.dropdown-menu > li {
  display: block;
  padding: 6px 15px;
  width: 100%;
  box-sizing: border-box;

  a{
    color: $my-black;
    font-size: 1em;
    padding: 10px 13px;
    text-decoration: none;
    font-family: 'Roboto', sans-serif;
  }
  a:hover{
    color: $my-orange;
    transition: .3s;
  }
}

.dropdown.open .dropdown-menu{
  display: block;
}

.dropdown > a{
  display: inline-block;
  position: relative;
  width: 100%;
  background: #ddd;
  text-decoration: none;
  padding: 10px 15px;
  border-radius: 5px;
  text-align: center;
  box-sizing: border-box;
}

.caret-down{
  position: absolute;
  right: 15px;
}
.loading-animate {
  border: 8px solid #f3f3f3;
  border-radius: 50%;
  border-top: 8px solid $my-blue;
  border-bottom: 8px solid $my-blue;
  width: 60px;
  height: 60px;
  -webkit-animation: spin 2s linear infinite;
  animation: spin 2s linear infinite;
}
.loading {
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
  z-index: 6;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
</style>
